function vani_AddressesToolClass(){
	this.addressesPaneDiv = null;
	this.enabledMove = false;
	this.oldcursor = "auto";
	this.vani_divAddresses = null;
	this.topPaneAddressesTool = null;
	this.vani_timeFloatingID = 0;
	this.nowX = 0;
	this.nowY = 0;
	this.offsetx = 0;
	this.offsety = 0;
	this.oldcursor = "auto";
	this.oldMoveFunc = null;
	this.oldUpFunc = null;
} 

vani_AddressesToolClass.prototype.replaceAll = function( oldStr,findStr,repStr ) {
    var srchNdx = 0; 
  var newStr = "";  
  while (oldStr.indexOf(findStr,srchNdx) != -1)  
  {
    newStr += oldStr.substring(srchNdx,oldStr.indexOf(findStr,srchNdx));
    newStr += repStr;
    srchNdx = (oldStr.indexOf(findStr,srchNdx) + findStr.length);
  }
  newStr += oldStr.substring(srchNdx,oldStr.length);
  return newStr;
}

vani_AddressesToolClass.prototype.replaceValueField = function(str)
{
    var Result;
    strResult = this.replaceJavascript(str);
    strResult = this.replaceAll(strResult, "'","&#39;");
    return strResult;
}

vani_AddressesToolClass.prototype.replaceJavascript = function(str)
{
    var strResult = str;
    strResult = this.replaceAll(strResult,"&","&amp;");
    strResult = this.replaceAll(strResult,"<","&lt;");
    strResult = this.replaceAll(strResult,">","&gt;");
    return strResult;
}


vani_AddressesToolClass.prototype.hideAddressesToolPane = function(){
	window.close();
}

vani_AddressesToolClass.prototype.createAddressesDiv = function(parentDiv){
	var objJson = win.ETAGLIVE.tool.main.strEmailAddresses.parseJSON();
	var objCol = objJson.Response.ResponseContent.Groups;
	var strHTML = "";
	if (objCol != null )
	{
	    strHTML += "<u>Mail Lists:</u><br/>";
	    for (var i=0; i<objCol.length; i++)               
	        strHTML += "<input name=\"vani_idCBEmailAddresses\" type=\"checkbox\" value='" + this.replaceValueField(objCol[i].Name) + "'>"+ this.replaceJavascript(objCol[i].Name) + "<br>";
        strHTML += " <hr> ";
    }
    objCol = objJson.Response.ResponseContent.Emails;
	if (objCol != null){
        strHTML += "<u>Emails:</u><br/>";	
	    for (var i=0; i<objCol.length; i++)               
	        strHTML += "<input name=\"vani_idCBEmailAddresses\" type=\"checkbox\" value='" + this.replaceValueField(objCol[i].Address) + "'>"+ this.replaceJavascript(objCol[i].Address) + "<BR>";    
    }
    document.getElementById("divAddressesStore").innerHTML =strHTML;       
}

vani_AddressesToolClass.prototype.saveAndHide = function(){
    var colAddresses = document.getElementsByName("vani_idCBEmailAddresses");
    var isHasSelected = false;
    var strAddressesSelected = "";
    if (typeof colAddresses.length == "undefined")
    {
        if (colAddresses.checked)
            isHasSelected = true;
        strAddressesSelected += colAddresses.value;              
    }
    else
        for (i=0; i< colAddresses.length; i++)
        {
            isHasSelected = true;
            if (colAddresses[i].checked && !this.CheckIncludedEmail(emailWin.document.getElementById("vani_idTBEmail").value, colAddresses[i].value))
            {
                if (strAddressesSelected != "")
                    strAddressesSelected += ", ";
                strAddressesSelected += colAddresses[i].value;
            }
        }
    if (!isHasSelected)
        alert('There is no item selected.');
    else
    {
        emailWin.etaglive_AddAddresses(strAddressesSelected);  
        this.hideAddressesToolPane();
    }
}

vani_AddressesToolClass.prototype.CheckIncludedEmail = function(strContainer,strAddress )
    {
        strContainer = strContainer.replace('&lt;', '<').replace('&gt;','>');
        strAddress = strAddress.replace('&lt;', '<').replace('&gt;','>');
        //refine strAddress
        var pos, pos1;
        pos= strAddress.indexOf('<');
        if (pos >= 0 && pos != strAddress.length-1)
        {
            pos1 = strAddress.indexOf('>');
            if (pos1 > pos)
                strAddress = strAddress.substr(pos + 1, pos1 - pos  - 1)
        }
        pos = strContainer.indexOf(strAddress);
        if (pos < 0)
            return false;
        var isFirstOK = false;
        var isLastOK = false;    
        if (pos == 0)    
            isFirstOK = true;
        else if (strContainer.charAt(pos-1)=='<' || strContainer.charAt(pos-1)==' ' || strContainer.charAt(pos-1)==',')    
            isFirstOK = true;
        pos += (strAddress.length - 1);    
        if (pos == strContainer.length - 1)    
            isLastOK = true;
        else if (strContainer.charAt(pos+1)=='>' || strContainer.charAt(pos+1)==' ' || strContainer.charAt(pos+1)==',')    
            isLastOK = true;    
        if (isLastOK && isFirstOK)
            return true;
        else
            return false;        
    }

var vani_objAddressesTool = new  vani_AddressesToolClass();
function vani_onload()
{
    vani_objAddressesTool.createAddressesDiv();
}
