if(!ETAGLIVE) var ETAGLIVE={};
if(!ETAGLIVE.tool) ETAGLIVE.tool={};
if(!ETAGLIVE.tool.interface) ETAGLIVE.tool.interface={};

ETAGLIVE.tool.interface = {
    postDataCached: {
            sPostData: "",
            isAsynch: false,
            func:null    
        },
    sessionTimeout: 1000*60*20,
    connectBefore: 0,
    asyncCached:
    {
        param1: null,
        param2: null
    }
}

with (ETAGLIVE.tool.interface)
{
    ETAGLIVE.tool.interface.CallJsonMethod = function(sMethodName, param1, param2, isAsynch, func)
    {
        var sPostData = "func=" + sMethodName;
        var sEncoded;
        if (param1 != "")
        {
            sPostData += "&UserRequest=";
            sEncoded = encodeURIComponent(param1);
            sPostData += sEncoded;
            if (param2 != "")
            {
                sPostData += "&DocumentInput=";
			    sEncoded = encodeURIComponent(param2);
			    sPostData += sEncoded; 
            }
        }
        sPostData += "&type=ff";
        PostHTTPData(sPostData, isAsynch,func)
    }

    ETAGLIVE.tool.interface.getSessionID = function()
    {
        var oBrowser = document.getElementById("etaglive_browserGetSessionID");
        oBrowser.contentWindow.Connect2GetSessionID(PostHTTPData);
    }

    ETAGLIVE.tool.interface.PostHTTPData = function(sPostData, isAsynch,func)
    {
        //calling callscript to get sessionID
        var currentTime = (new Date()).getTime();
        if (currentTime - connectBefore > sessionTimeout)
        {
            connectBefore = (new Date()).getTime();
            postDataCached.sPostData = sPostData;
            postDataCached.isAsynch = isAsynch;
            postDataCached.func = func;
            getSessionID();
            return null;
        }
        else if (ETAGLIVE.tool.main.sessionID == "")
       {
            postDataCached.sPostData = sPostData;
            postDataCached.isAsynch = isAsynch;
            postDataCached.func = func;
            getSessionID();
            return null;
       }
       connectBefore = (new Date()).getTime();
       if (typeof sPostData == "undefined")
       {
            sPostData = postDataCached.sPostData;
            isAsynch = postDataCached.isAsynch;
            func = postDataCached.func;
       }
        var req = new XMLHttpRequest();
        var url = ETAGLIVE.tool.main.url;
        url = url.substr(0,url.lastIndexOf("/")+1) + "(S(" + ETAGLIVE.tool.main.sessionID + "))" + url.substr(url.lastIndexOf("/"));
        req.open("POST", url, isAsynch);
        req.setRequestHeader("Content-Length", sPostData.length);
        req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        req.setRequestHeader("Connection", "close");
        req.send(sPostData);
        if (isAsynch)
        {
            req.onreadystatechange = function() {//Call a function when the state changes.
                
	            if(req.readyState == 4 && req.status == 200) {
		            func(req.responseText);
	                }
                }
        }
        else
            func(req.responseText);
    }
}