if(!ETAGLIVE) var ETAGLIVE={};
if(!ETAGLIVE.tool) ETAGLIVE.tool={};
if(!ETAGLIVE.tool.operation) ETAGLIVE.tool.operation={};
ETAGLIVE.tool.operation = {
    SAVETEXT: 1, 
    SAVEBLOCK: 2,
    SAVEBOOKMARK: 3,
    actionAfterLogin: null,
    actionAfterSignup: null,
    JumpID:0,
    saveDataCached: 
    {
        sCaptchaKey:"",
        sFolderIDs:"",
        sDocumentRequest:"",
        sAddressText:"",
        sSubject:"",
        sNote:"",
        sSaveAction: 0,
        isEmail: false
    }        
}

with (ETAGLIVE.tool.operation)
{
    ETAGLIVE.tool.operation.save = function(type)
    {
        if (!ETAGLIVE.tool.TabControl.activeContext)
            return;
        var context = ETAGLIVE.tool.TabControl.activeContext;
        var toolbarObj = context.toolbar;
        var browser = context.browser;
        context.document = browser.contentDocument;
        context.title = document.title;
        if (context.document.getElementById("vani_noteTool") != null)
            return;
        context.idMenuSelecting = type;
        if (type == SAVEBLOCK)    
            toolbarObj.createSelectionBar();
        if (!ETAGLIVE.tool.main.isLogin && type != SAVEBLOCK) // allow user to activate the tool without login
        {
            actionAfterLogin = saveAfterLogin
            ETAGLIVE.tool.main.LogIn();
            actionAfterLogin = null;
        }
        else
            saveAfterLogin(true, type);    
    }

    ETAGLIVE.tool.operation.saveAfterLogin = function(loginSuccess,type)
    {
        if (!ETAGLIVE.tool.TabControl.activeContext)
            return;
        var context = ETAGLIVE.tool.TabControl.activeContext;
        var toolbarObj = context.toolbar;
        var browser = context.browser;
        if (typeof type == "undefined")
            type = context.idMenuSelecting;
        if (!loginSuccess && type != SAVEBLOCK) 
            return;
        
        if (type == SAVEBLOCK)
        {
            var tabbrowser = document.getElementById("content");
            var notificationbox = tabbrowser.getNotificationBox(browser);
            context.toolbar.notification =  notificationbox.appendNotification("Hover the mouse cursor over the desired videos, images, or sections. Left click to select. Click \"OK/Continue\" above when done.");
        } 
        if (type != SAVEBOOKMARK)
        {
            if (context.document.body.nodeName == "BODY")
                context.isBody = true;
            else
                context.isBody = false;    
            if (type == SAVETEXT  && !context.isBody)
            {
                var strUrlNote = ETAGLIVE.tool.main.noteurl + "?ClientID=" +ETAGLIVE.tool.main.loginStruct.ClientID + "&RequestCookie=" + ETAGLIVE.tool.main.loginStruct.RequestCookies;
                browser.contentWindow.open(strUrlNote, null, "height=400,width=675,status=yes,toolbar=no,menubar=no,location=no,resizable=yes")
                return;
            }
            window.setTimeout(doInsertScript, 100); // for login user to hide quickly
        }
        else
        {
            window.setTimeout(showBookmarTree, 100);
        }
    }

    ETAGLIVE.tool.operation.doInsertScript = function()
    {
        var context = ETAGLIVE.tool.TabControl.activeContext;
        var toolbarObj = context.toolbar;
        var browser = context.browser;   
        var type = context.idMenuSelecting; 
        //test readfile
        var ioService=Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
        var scriptableStream=Components.classes["@mozilla.org/scriptableinputstream;1"].getService(Components.interfaces.nsIScriptableInputStream);
        var line;
        var filePath;
        if (type == SAVETEXT)
        {filePath = "chrome://etaglive/content/textpaneiframe.js";}
        else
        {filePath = "chrome://etaglive/content/AreaSelection.js";
        }
        var channel=ioService.newChannel(filePath,'UTF-8',null);
        var input=channel.open();
        scriptableStream.init(input);
        line=scriptableStream.read(input.available());
        scriptableStream.close();
        input.close();
        if (type == SAVETEXT)
        {
            line =ETAGLIVE.tool.utils.replaceAll(line, "<<userid>>", ETAGLIVE.tool.main.loginStruct.ClientID);
            line =ETAGLIVE.tool.utils.replaceAll(line, "<<RequestCookie>>", ETAGLIVE.tool.main.loginStruct.RequestCookies);
            addScript("vani_noteTool",line,browser.contentWindow.document);
        }
        if (type == SAVEBLOCK)
        {
            browser.contentWindow.addEventListener("pagehide", pagehideHandler,false);
            insertScript2Frames(line, browser.contentWindow, context);
        }
    }

    ETAGLIVE.tool.operation.showBookmarTree = function()
    {
        var context = ETAGLIVE.tool.TabControl.activeContext;
        var btn = document.getElementById(context.toolbar.prefix("eTagLive-BookmarkSave"))
        var box = btn.boxObject;
        var x =  box.screenX;
        var y = box.screenY + box.height;
        window.open("chrome://etaglive/content/tree.htm", "etaglive-bookmark", "left=" + x + ",top=" + y + ",width=285,height=358,chrome,dialog,modal,close=no,titlebar=no,scrollbars=no");
    }

    ETAGLIVE.tool.operation.insertScript2Frames = function(line, win, context)
    {
        var doc = win.document;
        if (doc.body.nodeName == "BODY")
        {
            try
            {
                sExec = "var vani_AddedCHiddenInputEle= document.createElement(\"input\");" ;
                sExec  = sExec  + "vani_AddedCHiddenInputEle.type = \"button\";";
                sExec  = sExec  + "vani_AddedCHiddenInputEle.style.display = \"none\";";
                sExec  = sExec  + "vani_AddedCHiddenInputEle.id = \"vani_AddedCHiddenInput\";";
	            sExec  = sExec +  "document.body.appendChild(vani_AddedCHiddenInputEle);";
		        sExec  = sExec  + "vani_AddedCHiddenInputEle.setAttribute(\"curValue\",\"0\");";
		        sExec  = sExec  + "vani_AddedCHiddenInputEle.setAttribute(\"preValue\",\"0\");";
		        if (!doc.getElementById("vani_AddedCHiddenInput"))
	                addScript("vani_AddedCHiddenScript",sExec,doc)
	            if (typeof win.vani_objAreaSelection == "undefined" || win.vani_objAreaSelection == null)    
	            {
	                line += "\nwindow.addEventListener(\"pagehide\",vani_objAreaSelection.Release, false);";
	                addScript("vani_mainSelection",line,doc);
	            }
    	            
	            var input = doc.getElementById("vani_AddedCHiddenInput");
	            if (input) 
	            {   
	                input.setAttribute("valuebefore","0");
	                input.setAttribute("curValue","0");
	                input.setAttribute("preValue","0");
	                input.addEventListener("click",selectionChanged, false);
	            }
	        }
	        catch(e){}    
	    }
    	
	    for (var i=0; i<win.frames.length; i++)
	    {
	        var childwin = win.frames[i];
	        insertScript2Frames(line, childwin, context);
	    }
    }

    ETAGLIVE.tool.operation.SaveOnly = function()
    {
        Save2Server(null, null, null, null);
    }

    ETAGLIVE.tool.operation.SaveAndSend = function()
    {
        Save2Server(saveDataCached.sAddressText, saveDataCached.sSubject, saveDataCached.sNote, saveDataCached.sCaptchaKey);
    }

    ETAGLIVE.tool.operation.Save2Server = function(email, subject, content, captcha)
    {
        var context = ETAGLIVE.tool.TabControl.activeContext;
        var win = context.browser.contentWindow.content;
        if (!ETAGLIVE.tool.main.isCaptchaIncorrectProcess)
            if (ETAGLIVE.tool.main.isUsingTemporary() && !ETAGLIVE.tool.utils.isHasPrefValue("ShowTempAccount"))
            {
                var logo = document.getElementById(ETAGLIVE.tool.TabControl.activeContext.toolbar.prefix("eTagLive-logo"))
                var box = logo.boxObject;
                var x =  box.screenX + box.width;
                var y = box.screenY + box.height;
                window.open("chrome://etaglive/content/tempaccountalert.html", "eTaglive-TempAccount-Alert", "left=" + x + ",top=" + y + ",width=343,height=193,chrome,dialog,modal,close=no,titlebar=no,scrollbars=no");
                if (ETAGLIVE.tool.main.reloginStatus == 1)
                {
                    ETAGLIVE.tool.main.reloginStatus = 0;
                    ETAGLIVE.tool.main.showSignUpDialog();
                }
                if (ETAGLIVE.tool.main.reloginStatus == 2)    
                {
                    ETAGLIVE.tool.main.reloginStatus = 0;
                    return;
                }
            }    
        if (!ETAGLIVE.tool.main.isCaptchaIncorrectProcess)    
            DoneScript(win);
        saveDataCached.sCaptchaKey = captcha;
        if (!ETAGLIVE.tool.main.isCaptchaIncorrectProcess)    
        {
            saveDataCached.sDocumentRequest = "\"DocumentCollection\":[";
	        if (context.idMenuSelecting == SAVEBLOCK)
	        {
	            saveDataCached.sDocumentRequest += GetFrameSaveRequest(context,win, false).substr(1);
	        }
	        else if (context.idMenuSelecting == SAVEBOOKMARK)
	        {
	            saveDataCached.sDocumentRequest += GetFrameSaveRequest(context,win, true).substr(1);
	        }
	        saveDataCached.sDocumentRequest += "]";
	        SendTreeNewFolder();
	        if (context.sNewFolderCreated.length > 0)
		        saveDataCached.sDocumentRequest += context.sNewFolderCreated;
    		    
		     saveDataCached.sFolderIDs = GetTagIDSelecteds(context);   
	    }
	    if (saveDataCached.sDocumentRequest == "")
	        return;
    	    
	    var strRequest = addEmailData2Request(saveDataCached.sDocumentRequest, email, subject, content, saveDataCached.sFolderIDs);    
    	
	    var sUserRequest = getRequestString(captcha);
	    var sFunctionName;
	    if (ETAGLIVE.tool.main.isCaptchaIncorrectProcess)
	    {
	        if (saveDataCached.sSaveAction== SAVEBLOCK)
		        sFunctionName = "SendBlock";
	        else if (saveDataCached.sSaveAction == SAVEBOOKMARK)
		        sFunctionName = "SendBookmark";
	    }
	    else
	    {
	        if (context.idMenuSelecting == SAVEBLOCK)
		        sFunctionName = "SendBlock";
	        else if (context.idMenuSelecting == SAVEBOOKMARK)
		        sFunctionName = "SendBookmark";
        }
	    saveDataCached.sAddressText = 	email;
	    saveDataCached.sSubject = 	subject;
	    saveDataCached.sNote = 	content;
	    saveDataCached.sSaveAction = 	context.idMenuSelecting;
	    saveDataCached.isEmail = (email != null);
	    if (!ETAGLIVE.tool.main.isCaptchaIncorrectProcess)
	        if (context.idMenuSelecting == SAVEBLOCK)
                Cancel();
        ETAGLIVE.tool.main.isCaptchaIncorrectProcess = false;           
	    ETAGLIVE.tool.interface.CallJsonMethod(sFunctionName, sUserRequest,strRequest, true, afterSaving);
    	     
    }

    ETAGLIVE.tool.operation.addEmailData2Request = function(sDocumentRequest, sAddressText, sSubject, sNote, sFolderIDs)
    {
        var strRequest = "{\"FolderIDs\":\"" + sFolderIDs + "\",";
        if (sAddressText != null && sAddressText != "")
	    {
		    strRequest +=  "\"Emails\":\"";
		    strRequest += ETAGLIVE.tool.utils.replaceJson(sAddressText);
		    strRequest +=  "\",";
		    strRequest +=  "\"Subject\":\"";
		    strRequest += ETAGLIVE.tool.utils.replaceJson(sSubject);
		    strRequest +=  "\",";
		    strRequest +=  "\"Note\":\"";
		    strRequest += ETAGLIVE.tool.utils.replaceJson(sNote);
		    strRequest +=  "\",";
	    }
	    strRequest += sDocumentRequest;
	    strRequest += "}"
	    return strRequest;
    }

    ETAGLIVE.tool.operation.getRequestString = function(captcha)
    {
        var sUserRequest;
        sUserRequest = "{";
	    sUserRequest = sUserRequest + "\"UserRequest\":{";
	    sUserRequest = sUserRequest + "\"User\":{\"RequestCookie\":\"" + ETAGLIVE.tool.main.loginStruct.RequestCookies + "\",";
	    sUserRequest = sUserRequest + "\"ClientID\":\"" + ETAGLIVE.tool.main.loginStruct.ClientID + "\"";
	    if (captcha != null && captcha != "" )
		    sUserRequest = sUserRequest + ",\"CaptchaResponse\":\"" + ETAGLIVE.tool.utils.replaceJson(captcha) + "\"";
	    sUserRequest = sUserRequest + "}";
	    sUserRequest = sUserRequest + "}";
	    sUserRequest = sUserRequest + "}";
	    return sUserRequest;
    }

    ETAGLIVE.tool.operation.SendTreeNewFolder = function()
    {
        var context = ETAGLIVE.tool.TabControl.activeContext;
        context.sNewFolderCreated = "";
        var objJson = ETAGLIVE.tool.main.sTreeFolder.parseJSON();
        BrowseTreeAndFormJsonNewFolder(context,objJson,0);
        if (context.sNewFolderCreated != "")
	    {
		    context.sNewFolderCreated = "," +context.sNewFolderCreated;
		    context.sNewFolderCreated += "]";
	    }
    }

    ETAGLIVE.tool.operation.BrowseTreeAndFormJsonNewFolder = function(context,objJson,parentID)
    {
        var isNewFolder = false;
        var FolderID = 0;
        if (typeof objJson[0] == "undefined")
        {
           FolderID = parseInt(objJson.FolderID);
           if (FolderID == 0)    
           {
                isNewFolder = true;
                if (context.sNewFolderCreated == "")
                    context.sNewFolderCreated = "\"NewFolders\":[";
                else if (parentID >= 0)
                    context.sNewFolderCreated  += ","; 
                context.sNewFolderCreated   += "{";
                if (parentID >=0)
			    {
				    context.sNewFolderCreated += "\"parentID\":";
				    context.sNewFolderCreated  +=  parentID;
				    context.sNewFolderCreated +=  ",";
			    }
			    var strName;
			    context.sNewFolderCreated += "\"Name\":\"";
			    context.sNewFolderCreated += ETAGLIVE.tool.utils.replaceJson(objJson.FolderName);
			    context.sNewFolderCreated  += "\"";
			    if (objJson.Selected == "Y")
				    context.sNewFolderCreated += ",\"Selected\":\"Y\"";
		        else
		            context.sNewFolderCreated += ",\"Selected\":\"N\"";
           }
           if (objJson.Children != null)
                objJson = objJson.Children
           else
           {
                if (isNewFolder)
				    context.sNewFolderCreated += "}";
			    return isNewFolder;
           }
        }
        var child;
        var hasChildNewFolder = false;        
        var i;
        var nChildParentID;
        if (objJson.length > 0)
        {
            if (isNewFolder)
			    context.sNewFolderCreated += ",\"Children\":[";
		    for (i=0; i<objJson.length; i++)
		    {	
			    child = objJson[i];
			    if ((!isNewFolder)&&(FolderID == 0))
				    nChildParentID = parentID;
			    else if (isNewFolder)
				    nChildParentID = -1;
			    else 
				    nChildParentID = FolderID; 
			    if (hasChildNewFolder && (nChildParentID == -1))
				    context.sNewFolderCreated += ",";
			    if (BrowseTreeAndFormJsonNewFolder(context,child, nChildParentID))
				    hasChildNewFolder= true;
		    }
		    if (isNewFolder)
			    context.sNewFolderCreated += "]";
        }
        if (isNewFolder)
		    context.sNewFolderCreated += "}";
	    return isNewFolder;
    }

    ETAGLIVE.tool.operation.afterSaving = function(response)
    {
        if (response == "Timeout" || response == "")
        {
            alert("Your session has expired. Please login.");
            ETAGLIVE.tool.main.sessionID = "";
            actionAfterLogin = timoutAfterLogin;
            ETAGLIVE.tool.main.LogIn();
            actionAfterLogin = null;
            return;
        }
        else 
        {
            var nResult = ParseSavingResponse(response) ;
            if (nResult == 1 || nResult == -1) //success or error return from server
               return;
            if (nResult == -2)   //email wrong captcha
            {
                ETAGLIVE.tool.main.isCaptchaIncorrectProcess = true;
                window.open("chrome://etaglive/content/Email.htm", "etaglive-email", "centerscreen,width=482,height=350,chrome,dialog,modal,close=no,titlebar=no,scrollbars=no");
            }
        }
    }

    ETAGLIVE.tool.operation.ParseSavingResponse = function(response)
    {
        var objJson = response.parseJSON();
        if (!objJson)
            return 0;
        var isSuccess = 0;
        if (typeof objJson.Response.ResponseCode != "undefined")
            if (objJson.Response.ResponseCode == "0")
                isSuccess = 1;
        if (objJson.Response.ResponseMessage)
            if (objJson.Response.ResponseMessage != "")
            {
                alert(objJson.Response.ResponseMessage);
                isSuccess = -1;
            } 
        if (objJson.Response.ResponseCode == "-4")    
            if (typeof objJson.Response.ResponseContent != 'undefined' && objJson.Response.ResponseContent != null)
                if (typeof objJson.Response.ResponseContent.CaptchaUrl != 'undefined' && objJson.Response.ResponseContent.CaptchaUrl != null)    
                {    
                    ETAGLIVE.tool.main.captchaurl =     objJson.Response.ResponseContent.CaptchaUrl;
                    if (ETAGLIVE.tool.main.captchaurl != "")
                        isSuccess = -2;
                }
        //folder  
        ETAGLIVE.tool.main.sTreeFolder = "";
        if (objJson.Response.ResponseContent.FoldersTree!= null)
            ETAGLIVE.tool.main.sTreeFolder = objJson.Response.ResponseContent.FoldersTree.toJSONString();    
        return isSuccess;     
    }

    ETAGLIVE.tool.operation.timoutAfterLogin = function(loginSuccess)
    {
        var sFunctionName;
        if (!loginSuccess)
        {
            alert("Send data to server failed");
            ETAGLIVE.tool.main.LogOut(null);
            return;
        }
        var sUserRequest = getRequestString(saveDataCached.sCaptchaKey);
        var strRequest = addEmailData2Request(saveDataCached.sDocumentRequest, saveDataCached.sAddressText, saveDataCached.sSubject, saveDataCached.sNote, saveDataCached.sFolderIDs);    
    	
	    if (saveDataCached.sSaveAction == SAVEBLOCK)
	        sFunctionName = "SendBlock";
	    else if (saveDataCached.sSaveAction == SAVEBOOKMARK)
		    sFunctionName = "SendBookmark";
	    else
	        return;	
	    ETAGLIVE.tool.interface.CallJsonMethod(sFunctionName, sUserRequest, strRequest, true, afterSaving) ;
    }

    ETAGLIVE.tool.operation.GetFrameSaveRequest = function(context,win, isbookmark)
    {
        var bFirst = true;
        var doc = win.document;
        var strRequest ="";
        if ((context.idMenuSelecting == SAVEBLOCK && doc.body.nodeName == "BODY" && doc.getElementById("vani_hiddenRequestStr") != null) || (isbookmark))
        {
            try
            {
                var strRequest  = ",{";
		        strRequest += "\"PageURL\":\"";	
		        var href = win.location.href;  
		        strRequest += ETAGLIVE.tool.utils.replaceJson(href);
		        strRequest += "\",";
		        strRequest += "\"PageTitle\":\"";	
		        strRequest += ETAGLIVE.tool.utils.replaceJson(context.title);
		        strRequest += "\",";
		        strRequest += "\"PageUserTitle\":\"";	
		        strRequest += ETAGLIVE.tool.utils.replaceJson(context.savedTitle);
		        strRequest += "\",";		
		        var strMetaDescription= "", strMetaKeywords = "";
		        var metaCols = doc.getElementsByTagName("meta");
		        for (var i=0; i < metaCols.length; i++)
                {
                    if (metaCols[i].name.toLowerCase() == "description")
                    {
                        if (strMetaDescription != "")
                            strMetaDescription += "\n";
                        strMetaDescription += metaCols[i].content;    
                    }
                    if (metaCols[i].name.toLowerCase() == "keywords")
                    {
                        if (strMetaKeywords != "")
                            strMetaKeywords += ",";
                        strMetaKeywords += metaCols[i].content;    
                    }    
                }
                if (strMetaDescription != "")
                {
                    strRequest += "\"MetaDescription\":\"";	
                    strRequest += ETAGLIVE.tool.utils.replaceJson(strMetaDescription);
                    strRequest += "\",";
                }
                if (strMetaKeywords != "")
                {
                    strRequest += "\"MetaKeywords\":\"";	
                    strRequest += ETAGLIVE.tool.utils.replaceJson(strMetaKeywords);
                    strRequest += "\",";
                }
                strRequest += "\"Header\":{";
                var i;
                var id;
                if (context.idMenuSelecting == SAVEBLOCK)
                {
                    var stylesheets = doc.styleSheets;
                    var stylesheet;
                    var bHasStyleSheet = false;
                    var strStyleSheet = "";
                    var strLinkStyleSheet = "";
                    for (i=0; i<stylesheets.length; i++)
                    {
                        stylesheet = stylesheets[i];
                        if (typeof stylesheet.nodeName != "undefined")
                            stylesheet = stylesheet.styleSheet;
                        var ownerElement;
                        if (stylesheet.owningElement)
                            ownerElement = stylesheet.owningElement;  
                        else
                            ownerElement = stylesheet.ownerNode;          
                        id = ownerElement.id;
                        if (id == undefined || id.indexOf("vani_css") !=0)   
                        {
                            if (!bHasStyleSheet)   
                            {
                                strRequest = strRequest + "\"StyleClasses\":\"<STYLE>";
				                bHasStyleSheet = true;
                            }
                            var rules;
                            try{
                            if (typeof stylesheet.rules != 'undefined')
                                rules= stylesheet.rules;
                            else
                                rules= stylesheet.cssRules;    
                            }
                            catch(ex)
                            {
                                rules = null;
                            }
                            if (rules)
                            for (var j=0; j<rules.length;j++)  
			                {
				                if (typeof rules[j].style != 'undefined')
				                {
				                    var selectorText = rules[j].selectorText; 
				                    var styleText = rules[j].style.cssText;
				                    if (!stylesheet.href)
				                        strStyleSheet += ETAGLIVE.tool.utils.replaceJson(selectorText + "{" + styleText + "}\n");  
				                    else    
				                        strLinkStyleSheet += ETAGLIVE.tool.utils.replaceJson(selectorText + "{" + styleText + "}\n");  
				                }       
			                }
		                }
                    }
                    strRequest += strLinkStyleSheet;
                    strRequest += strStyleSheet;
                    if (bHasStyleSheet)
                        strRequest+="</STYLE>\",";
                }
                strRequest += "\"Cookies\":\"";
                strRequest += ETAGLIVE.tool.utils.replaceJson(doc.cookie);
                strRequest += "\"";
                strRequest += "}";	//close header
                if (context.idMenuSelecting == SAVEBLOCK)
                {
                    strRequest += ",";
                    strRequest += "\"CustomData\":\"";
                    strRequest += doc.getElementById("vani_hiddenCustomStr").value;
                    strRequest += "\",";
                    strRequest+="\"Blocks\":[";
                    strRequest += doc.getElementById("vani_hiddenRequestStr").value;
                    strRequest+="]";
                }
                strRequest += "}";
            }
	        catch(e){}        
	    }
	    if (!isbookmark)
	        for (var i=0; i<win.frames.length; i++)
	        {
	            var childwin = win.frames[i];
	            strRequest += GetFrameSaveRequest(context,childwin, isbookmark);
	        }
	    return strRequest;    
    }

    ETAGLIVE.tool.operation.GetTagIDSelecteds = function(context)
    {
        var strResult = "";
        for (var i=0; i < context.arrNodeSelected.length; i ++)
        {
            if (i!=0)
                strResult += ",";
            strResult +=  context.arrNodeSelected[i];   
        }
        return strResult;
    }

    ETAGLIVE.tool.operation.DoneScript = function(win)
    {
        var doc = win.document;
        if (doc.body.nodeName == "BODY")
        {
            try
            {
        //        if (typeof win.vani_objAreaSelection != "undefined" && win.vani_objAreaSelection != null)    
                {
                    addScript("","vani_objAreaSelection.DoneClicked();",doc);
                }
            }
	        catch(e){}        
	    }
	    for (var i=0; i<win.frames.length; i++)
	    {
	        var childwin = win.frames[i];
	        DoneScript(childwin);
	    }
    }

    ETAGLIVE.tool.operation.Cancel = function(contextparam)
    {
        var context;
        if (!context)
        {
            if (!ETAGLIVE.tool.TabControl.activeContext)
                return;
            context = ETAGLIVE.tool.TabControl.activeContext;
        }
        else
            context = contextparam;     
        context.toolbar.destroySelectionToolbar();
        runCancelScript(context.browser.contentWindow.content);
    }

    ETAGLIVE.tool.operation.runCancelScript = function(win)
    {
        var doc = win.document;
        if (doc.body.nodeName == "BODY")
        {
            try
            {
        //        if (typeof win.vani_objAreaSelection != "undefined" && win.vani_objAreaSelection != null)    
                {
                    addScript("","vani_objAreaSelection.CancelClicked();",doc);
                }
            }
	        catch(e){}        
	    }
	    for (var i=0; i<win.frames.length; i++)
	    {
	        var childwin = win.frames[i];
	        runCancelScript(childwin);
	    }
    }

    ETAGLIVE.tool.operation.labelIt = function()
    {
        if (!ETAGLIVE.tool.TabControl.activeContext)
            return;
        var context = ETAGLIVE.tool.TabControl.activeContext;
        if (context.nUnitsSelected == 0)
        {
            alert("Please choose at least one area.")
            return;
        }
        if (!ETAGLIVE.tool.main.isLogin)
        {
            actionAfterLogin = new Function("window.setTimeout(ETAGLIVE.tool.operation.showCaptureTree, 100)");
            ETAGLIVE.tool.main.LogIn();
            actionAfterLogin = null;
        }
        else
            showCaptureTree(true);
    }

    ETAGLIVE.tool.operation.showCaptureTree = function()
    {
        if (!ETAGLIVE.tool.TabControl.activeContext)
            return;
        var context = ETAGLIVE.tool.TabControl.activeContext;
        if (!ETAGLIVE.tool.main.isLogin) 
            return;
        else
        {
            var btn = document.getElementById(context.toolbar.prefix("eTagLive-LabelItBtn"))
            var box = btn.boxObject;
            var x =  box.screenX;
            var y = box.screenY + box.height;
            window.open("chrome://etaglive/content/tree.htm", "etaglive-LabelIt", "left=" + x + ",top=" + y + ",width=285,height=358,chrome,dialog,modal,close=no,titlebar=no,scrollbars=no");
        }
    }

    ETAGLIVE.tool.operation.pagehideHandler = function(eve)
    {
        var doc= eve.target;
        var context = ETAGLIVE.tool.TabControl.findContext(doc);
        if (!context)
            return;
        var browser = context.browser;
        browser.contentWindow.removeEventListener("pagehide",pagehideHandler, false);
        context.toolbar.destroySelectionToolbar();
        Cancel(context);
    }

    ETAGLIVE.tool.operation.selectionChanged = function(eve)
    {
         var objInput = eve.target;
         if (!ETAGLIVE.tool.TabControl.activeContext)
            return;
        var context = ETAGLIVE.tool.TabControl.activeContext;
        if (objInput.id != "vani_AddedCHiddenInput")
            objInput = objInput.ownerDocument.getElementById("vani_AddedCHiddenInput");
        if (!objInput)    
            return;
        context.toolbar.showSelectionNumbers(parseInt(objInput.getAttribute("curValue")) - parseInt(objInput.getAttribute("preValue")));
        objInput.setAttribute("preValue", objInput.getAttribute("curValue"));
    }

    ETAGLIVE.tool.operation.addScript = function(scriptname,line,doc)
    {
        try
        {
            var parentTag = null;
            var list= doc.getElementsByTagName("HEAD");
            if (list.length > 0)
                parentTag = list[0];
            else if (doc.body.nodeName == "BODY")
                parentTag = doc.body;    
            if (parentTag)    
            {
                var oScript = doc.createElement("script");
                oScript.setAttribute('language', 'Javascript');
                if (scriptname != "")
                    oScript.setAttribute('id', scriptname);
                var oTextNode = doc.createTextNode(line);
		        oScript.appendChild(oTextNode);
		        parentTag.appendChild(oScript);
    		    
		        return true;
		    } 
		    return false;
        }
        catch(e)    
        {return false;}
    }

    ETAGLIVE.tool.operation.mySavedItems = function()
    {
        if (!ETAGLIVE.tool.main.isLogin)
        {
            actionAfterLogin = MyItemsAfterLogin
            ETAGLIVE.tool.main.LogIn();
            actionAfterLogin = null;
        }
        else
            MyItemsAfterLogin(true);    
    }

    ETAGLIVE.tool.operation.MyItemsAfterLogin = function(loginSuccess)
    {
        if (!loginSuccess)
            return;
        window.setTimeout(showMyItemsTree, 100);    
    }

    ETAGLIVE.tool.operation.showMyItemsTree = function()
    {
        var context = ETAGLIVE.tool.TabControl.activeContext;
        var btn = document.getElementById(context.toolbar.prefix("eTagLive-MyItems"))
        var box = btn.boxObject;
        var x =  box.screenX;
        var y = box.screenY + box.height;
        window.open("chrome://etaglive/content/MyClips.htm", "etaglive-MyItems", "left=" + x + ",top=" + y + ",width=352,height=200,chrome,dialog,modal,close=no,titlebar=no,scrollbars=no");
    }

    ETAGLIVE.tool.operation.jump2Page = function()
    {
        var context = ETAGLIVE.tool.TabControl.activeContext;
        try{
        context.browser.contentWindow.location.href = ETAGLIVE.tool.main.urlhome + "?ClientID=" + window.ETAGLIVE.tool.main.loginStruct.ClientID + "&RequestCookie=" + window.ETAGLIVE.tool.main.loginStruct.RequestCookies + '&id=' + JumpID;
        }catch(e){alert(e)}
    }
}