if(!ETAGLIVE) var ETAGLIVE={};
if(!ETAGLIVE.tool) ETAGLIVE.tool={};
if(!ETAGLIVE.tool.utils) ETAGLIVE.tool.utils={};
ETAGLIVE.tool.utils = {
    preferences: null
}
with (ETAGLIVE.tool.utils) 
{
    ETAGLIVE.tool.utils.getPreferences = function()
    {
        if(!preferences)
            preferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.etaglive.");
        return preferences;
    }

    ETAGLIVE.tool.utils.isHasPrefValue = function(preference)
    {
        if (preference)
        {
            return getPreferences().prefHasUserValue(preference);
        }
        else
            return false;
    }

    ETAGLIVE.tool.utils.getPrefString = function(preference)
    {
        if (preference)
            if (isHasPrefValue(preference))
            {
                try
                {
                    return getPreferences().getCharPref(preference);
                }
                catch(exception) 
                {
                }
            }
       return "";     
    }

    ETAGLIVE.tool.utils.getPrefBool = function(preference)
    {
        if (preference)
            if (isHasPrefValue(preference))
            {
                try
                {
                    return getPreferences().getBoolPref(preference);
                }
                catch(exception) 
                {
                }
            }
       return false;     
    }

    ETAGLIVE.tool.utils.setPrefBool = function(preference, value)
    {
        if (preference)
            try
            {
                getPreferences().setBoolPref(preference, value);
            }
            catch(exception) 
            {
            }
    }

    ETAGLIVE.tool.utils.setPrefString = function(preference, value)
    {
        if (preference)
            try
            {
                getPreferences().setCharPref(preference, value);
            }
            catch(exception) 
            {
            }
    }

    ETAGLIVE.tool.utils.replaceJson = function(str)
    {
        var strResult = str;
        strResult = replaceAll(strResult,"\\","\\\\");
        strResult = replaceAll(strResult,"\"","\\\"");
    //    strResult = this.replaceAll(strResult,"/", "\\/");
	    strResult = replaceAll(strResult,"\b", "\\b");
	    strResult = replaceAll(strResult,"\t", "\\t");
	    strResult = replaceAll(strResult,"\n", "\\n");
	    strResult = replaceAll(strResult,"\f", "\\f");
	    strResult = replaceAll(strResult,"\r", "\\r");
        return strResult;
    }

    ETAGLIVE.tool.utils.replaceAll = function( oldStr,findStr,repStr ) {
        var srchNdx = 0; 
      var newStr = "";  
      while (oldStr.indexOf(findStr,srchNdx) != -1)  
      {
        newStr += oldStr.substring(srchNdx,oldStr.indexOf(findStr,srchNdx));
        newStr += repStr;
        srchNdx = (oldStr.indexOf(findStr,srchNdx) + findStr.length);
      }
      newStr += oldStr.substring(srchNdx,oldStr.length);
      return newStr;
    }
}

if (!String.trim)
    String.prototype.trim = function() {
	        return this.replace(/^\s+|\s+$/g,"");
        }

